import { ETypes, Relationships, Schema, yams } from "ra-cubicweb/dist/Schema";

function makeSchema<E extends ETypes, R extends Relationships<E>>(
  etypes: E,
  relationships: R
): Schema<E, R> {
  return {
    etypes,
    relationships,
  };
}

export const schema = makeSchema(
  {
    Museum: {
      name: yams.String(),
      latitude: yams.Float(),
      longitude: yams.Float(),
      postal_address: yams.String(),
    },
    City: {
      name: yams.String(),
      zip_code: yams.Int(),
    },
    Person: {
      name: yams.String(),
      email: yams.String(),
    },
  },
  {
    is_in: {
      subject: "Museum",
      object: "City",
      cardinality: "1*",
    },
    director: {
      subject: "Museum",
      object: "Person",
      cardinality: "**",
    },
  }
);
